<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="会员ID" prop="userId">
        <el-input v-model="formData.userId" placeholder="请输入会员ID" />
      </el-form-item>
      <el-form-item label="货币类型" prop="currencyType">
        <el-select v-model="formData.currencyType" placeholder="请选择货币类型">
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.MEMBER_USER_CRYPTO_CURRENCY_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="货币地址" prop="address">
        <el-input v-model="formData.address" placeholder="请输入货币地址" />
      </el-form-item>
      <el-form-item label="标签" prop="label">
        <el-input v-model="formData.label" placeholder="请输入标签" />
      </el-form-item>
      <el-form-item label="是否默认" prop="primary">
        <el-input v-model="formData.primary" placeholder="请输入是否默认" />
      </el-form-item>
      <el-form-item label="二维码" prop="qrCode">
        <el-input v-model="formData.qrCode" placeholder="请输入二维码" />
      </el-form-item>
      <el-form-item label="目标标签" prop="cryptoTag">
        <el-input v-model="formData.cryptoTag" placeholder="请输入目标标签" />
      </el-form-item>
      <el-form-item label="是否验证" prop="verified">
        <el-input v-model="formData.verified" placeholder="请输入是否验证" />
      </el-form-item>
      <el-form-item label="网络" prop="network">
        <el-input v-model="formData.network" placeholder="请输入网络" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { DICT_TYPE, getStrDictOptions } from '@/utils/dict'
import * as UserCryptoApi from '@/api/member/userCrypto'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  userId: undefined,
  currencyType: undefined,
  address: undefined,
  label: undefined,
  primary: undefined,
  qrCode: undefined,
  cryptoTag: undefined,
  verified: undefined,
  network: undefined
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await UserCryptoApi.getUserCrypto(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as UserCryptoApi.UserCryptoVO
    if (formType.value === 'create') {
      await UserCryptoApi.createUserCrypto(data)
      message.success(t('common.createSuccess'))
    } else {
      await UserCryptoApi.updateUserCrypto(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    userId: undefined,
    currencyType: undefined,
    address: undefined,
    label: undefined,
    primary: undefined,
    qrCode: undefined,
    cryptoTag: undefined,
    verified: undefined,
    network: undefined
  }
  formRef.value?.resetFields()
}
</script>
